﻿using System;
using System.Collections.Generic;
using Medsphere.OpenVista.Remoting;
using Medsphere.OpenVista.Shared;
using System.Windows.Forms;
using System.Net;

namespace On_Call_Signout
{
    class GlobalVars
    {
        public static DataConnection dc;
        public static string filename = "";
        public static string currentpatientDFN = "";
        public static string currentpatientMRN = "";
        public static string currentpatientName = "";
        public static string currentpatientLocation = "";
        public static string currentpatientAdmissionDate = "";
        public static int retries = 0;                
        public static string patwardien = "";
        public static int DUZ = 0;        
        public static int CurrentUserDUZ;
        public static int NumberToReturn = 200;
        public static bool pageloaded = false;
        public static string CurrentUserService = "";
        public static string SelectedDivision = "";

        public class LType
        {
            public string NameText { get; set; }
            public int iIEN { get; set; }
        }

        public class SType
        {
            public string Phrase { get; set; }
            public string Abbreviation { get; set; }
        }

        public class NType
        {
            public string facilityUID { get; set; }
            public string documentUID { get; set; }
            public string facility { get; set; }
            public string facilityPatID { get; set; }
            public string documentLOINC { get; set; }
            public string documentTitle { get; set; }
            public string documentEncoding { get; set; }
            public string documentDateTime { get; set; }
            public string showInCombo { get; set; }
            public string valueForCombo { get; set; }
            public string authorInstitution { get; set; }
        }

        
        
        public static string RunRPC(string RPCName, string Arguments)
        {
            string strRet;
            strRet = "";
            try
            {
                if (GlobalVars.dc != null)
                {
                    strRet = GlobalVars.dc.CallRPC(RPCName, Arguments);
                    retries = 0;
                }
            }
            catch
            {
                retries++;
                if (retries > 3) //allow three total retries
                {
                    MessageBox.Show("Application Closed Due to Trouble Calling Remote Procedure: " + RPCName + "!");
                    Application.Exit();
                }
            }
            return strRet;
        }
        public static string FilemanDateTimeStringToExternalString(string FilemanDateTime)
        {
            string retval = "";
            string[] splitfmdt = Common.Split(FilemanDateTime, '.');
            if (splitfmdt.Length > 0)
            {
                if (splitfmdt[0].Length == 7)
                {
                    int ires;
                    string strcentury = splitfmdt[0].Substring(0, 1);
                    bool ok = Int32.TryParse(strcentury, out ires);
                    if (ok)
                    {
                        int century = (ires + 17) * 100;
                        strcentury = century.ToString();
                        string stryear = splitfmdt[0].Substring(1, 2);
                        ok = Int32.TryParse(stryear, out ires);
                        if (ok)
                        {
                            int fourdigityear = century + ires;
                            string twodigitmonth = splitfmdt[0].Substring(3, 2);
                            string twodigitday = splitfmdt[0].Substring(5, 2);
                            retval = twodigitmonth + "/" + twodigitday + "/" + fourdigityear.ToString();
                            if (splitfmdt.Length == 2)
                            {
                                string time = "";
                                switch (splitfmdt[1].Length)
                                {
                                    case 0:
                                        time = "";
                                        break;
                                    case 1:
                                        time = splitfmdt[1].Substring(0, 1) + "0:00";
                                        break;
                                    case 2:
                                        time = splitfmdt[1].Substring(0, 2) + ":00";
                                        break;
                                    case 3:
                                        time = splitfmdt[1].Substring(0, 2) + ":" + splitfmdt[1].Substring(2, 1) + "0";
                                        break;
                                    case 4:
                                        time = splitfmdt[1].Substring(0, 2) + ":" + splitfmdt[1].Substring(2, 2);
                                        break;
                                    case 5:
                                        time = splitfmdt[1].Substring(0, 2) + ":" + splitfmdt[1].Substring(2, 2) + ":" + splitfmdt[1].Substring(4, 1) + "0";
                                        break;
                                    case 6:
                                        time = splitfmdt[1].Substring(0, 2) + ":" + splitfmdt[1].Substring(2, 2) + ":" + splitfmdt[1].Substring(4, 2);
                                        break;
                                    default:
                                        time = "";
                                        break;
                                }
                                retval = retval + " " + time;
                            }
                            
                        }
                    }
                }
            }            
            return retval;
        }

        public static string ShortDateStringToFilemanDateString(string shortdatestring)
        {
            string fdate = "";
            string century = "";
            string year = "";
            string day = "";
            string month = "";
            string time = "";
            string timepiece = "";
            string[] pieces = shortdatestring.Split(' ');
            string datepiece = pieces[0];
            if (pieces.Length > 1)
            {
                timepiece = pieces[1];
            }
            else
            {
                timepiece = "0000";
            }
            string[] splitdate = datepiece.Split('/');
            if (splitdate[0].Length == 1)
            {
                splitdate[0] = "0" + splitdate[0];
            }
            if (splitdate[1].Length == 1)
            {
                splitdate[1] = "0" + splitdate[1];
            }
            datepiece = splitdate[0] + "/" + splitdate[1] + "/" + splitdate[2];
            if (datepiece.Substring(6, 2) == "19")
            {
                century = "2";
            }
            else if (datepiece.Substring(6, 2) == "20")
            {
                century = "3";
            }
            else if (datepiece.Substring(6, 2) == "21")
            {
                century = "4";
            }
            year = datepiece.Substring(8, 2);
            month = datepiece.Substring(0, 2);
            day = datepiece.Substring(3, 2);
            time = timepiece.Replace(":", "");
            fdate = century + year + month + day + "." + time;
            return fdate;
        }

        public static string FilemanDateStringToShortDateString(string filemandatestring)
        {
            string sdate = "";
            string century = "";
            string year = "";
            string day = "";
            string month = "";
            string time = "";
            if (filemandatestring.Substring(0, 1) == "2")
            {
                century = "19";
            }
            else if (filemandatestring.Substring(0, 1) == "3")
            {
                century = "20";
            }
            else if (filemandatestring.Substring(0, 1) == "4")
            {
                century = "21";
            }
            year = filemandatestring.Substring(1, 2);
            month = filemandatestring.Substring(3, 2);
            day = filemandatestring.Substring(5, 2);
            if (filemandatestring.Split('.').Length > 1)
            {
                time = (filemandatestring.Split('.')[1]);
            }
            else
            {
                time = "";
            }
            if (time.Length < 4)
            {
                time = time.PadRight(4, '0');
            }
            if (time.Length > 4)
            {
                time = time.Substring(0, 4);
            }
            sdate = month + "/" + day + "/" + century + year + "@" + time;
            return sdate;
        }
    }
}
