﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Medsphere.OpenVista.Remoting;
using Medsphere.OpenVista.Shared;
using System.Web;
using System.Security.Principal;
using System.DirectoryServices.AccountManagement;
using Microsoft.Web.WebView2.Core;
using System.IO;


namespace On_Call_Signout
{
    public partial class ShowStickyNotes : Form
    {
        public ShowStickyNotes()
        {
            InitializeComponent();
        }

        private void SelectDocument_Shown(object sender, EventArgs e)
        {
            string[] args6 = { GlobalVars.currentpatientDFN };
            string THIS_ARG = RpcFormatter.FormatArgs(true, args6);
            string res = GlobalVars.RunRPC("ORWPT SELECT", THIS_ARG);
            if (res != "")
            {
                string[] pieces = res.Split('^');
                if (pieces.Length > 19)
                {
                    GlobalVars.currentpatientName = pieces[0];
                    GlobalVars.currentpatientMRN = pieces[19];
                    
                }
            }

            textBoxPatientName.Text = GlobalVars.currentpatientName;
            textBoxMRN.Text = GlobalVars.currentpatientMRN;

            this.comboBoxTimePeriod.SelectedIndexChanged -= new System.EventHandler(this.comboBoxTimePeriod_SelectedIndexChanged);
            comboBoxTimePeriod.SelectedIndex = 5; //90 Days
            this.comboBoxTimePeriod.SelectedIndexChanged += new System.EventHandler(this.comboBoxTimePeriod_SelectedIndexChanged);

            comboBoxDocs.DisplayMember = "showInCombo";
            comboBoxDocs.ValueMember = "valueForCombo";
            //C9C HIE GETDOCS
            string numDays = comboBoxTimePeriod.Text;
            if (numDays == "")
            {
                numDays = "90";
            }

            string[] args1 = { GlobalVars.currentpatientDFN, numDays };
            THIS_ARG = RpcFormatter.FormatArgs(true, args1);
            res = GlobalVars.RunRPC("C9C HIE GETDOCS", THIS_ARG);            
            res = res.Replace("\r", string.Empty);
            
            string[] results = Common.Split(res, '\n');
            
            if (results.Length > 0)
            {                
                if (results[0].Trim(' ') == "XDSTooManyResults")
                {                    
                    labelMessage.Text = "Too Many Results To Return - Try a Shorter Timespan!";
                    Application.DoEvents();
                    labelMessage.Refresh();
                    comboBoxDocs.Enabled = false;
                }
                else if((results[0].Trim(' ') == "HIE Documents Not Found For This Patient!") || (results[0].Trim(' ') == "Patient Not Found/Not Matched in HIE!")
                                            || (results[0].Trim(' ') == "Could Not Communicate With the HIE!")
                                            || (results[0].Trim(' ').StartsWith("ERROR")))
                {
                    labelMessage.Text = results[0];
                    Application.DoEvents();
                    
                    labelMessage.Refresh();
                    comboBoxDocs.Enabled = false;
                }
                else
                {                    
                    //labelMessage.Text = "Attempting to Initialize the WebView2 Component...";
                    for (int q = 0; q < results.Length; q++)
                    {
                        
                        string[] thisresult = Common.Split(results[q], '%');                        
                        if (thisresult.Length > 12)
                        {
                            if (thisresult[12] == "")
                            {
                                thisresult[12] = thisresult[2]; //Use facility if author institution is blank
                            }
                            var thisitem = new GlobalVars.NType
                            {
                                facilityUID = thisresult[0],
                                documentUID = thisresult[1],
                                facility = thisresult[2],  //this is actually sending system, maybe AllScripts, etc
                                facilityPatID = thisresult[3],
                                documentLOINC = thisresult[5],
                                documentTitle = thisresult[6],
                                documentEncoding = thisresult[7],
                                documentDateTime = thisresult[8],
                                authorInstitution = thisresult[12],
                                showInCombo = thisresult[8].PadRight(25) + thisresult[4].PadRight(50) + thisresult[12],
                                valueForCombo = thisresult[0] + "%" + thisresult[1]
                            };
                            comboBoxDocs.Items.Add(thisitem);

                        }
                    }
                }
            }

            if ((comboBoxDocs.Items.Count == 0) || ((comboBoxDocs.Items.Count ==1) && (comboBoxDocs.Items[0].ToString().Trim()=="")))
            {                
                if (labelMessage.Text == "")
                {                    
                    labelMessage.Text = "HIE Documents Not Found For This Patient During the Selected Time Period!";
                }
            }
            else
            {
                labelMessage.Text = "";
            }
            Cursor.Current = Cursors.Default;
        }

        private string GetNewTempFile(string extension)
        {
            if (!extension.StartsWith(".")) extension = "." + extension;
            string fileName;
            bool bCollisions = false;
            do
            {
                fileName = Path.Combine(System.IO.Path.GetTempPath(), Guid.NewGuid().ToString() + extension);
                try
                {
                    using (new FileStream(fileName, FileMode.CreateNew)) { }
                    bCollisions = false;
                }
                catch (IOException)
                {
                    bCollisions = true;
                }
            }
            while (bCollisions);
            return fileName;
        }
        private void comboBoxDocs_SelectedIndexChanged(object sender, EventArgs e)
        {
            
            
            if (comboBoxDocs.SelectedIndex > -1 )
            {
                if (GlobalVars.filename != "")
                {
                    File.Delete(GlobalVars.filename);
                    GlobalVars.filename = "";
                }
                GlobalVars.pageloaded = false;
                int counter = 0;
                comboBoxDocs.Refresh();
                webView21.CoreWebView2.NavigateToString("<p>Querying the HIE...</p>");
                Cursor.Current = Cursors.WaitCursor;
                Application.DoEvents();
                do
                {
                    counter++;
                }                
                while ((GlobalVars.pageloaded == false) && (counter < 1000000000));
                Application.DoEvents();
                string UIDs = ((GlobalVars.NType)(comboBoxDocs.Items)[comboBoxDocs.SelectedIndex]).valueForCombo;
                
                string[] IDs = Common.Split(UIDs, '%');
                if (IDs.Length == 2)
                {
                    string repo = IDs[0];
                    string docid = IDs[1];
                    labelRepository.Text = "Repository ID: " + repo;
                    labelDoc.Text = "Document ID: " + docid;
                    string[] args1 = { repo, docid };
                    string THIS_ARG = RpcFormatter.FormatArgs(true, args1);
                    string res = GlobalVars.RunRPC("C9C HIE GET1DOC", THIS_ARG);
                    Boolean large = false;
                    if (res == "")
                    {
                        res = "<p>Document Not Found Or The Request Timed Out!</p><p>The Document May Be Too Large Or The System May Be Too Busy.</p><p>Repository ID=" + IDs[0] + "</p>" + "<p>Document ID=" + IDs[1] + "</p>";
                    }

                    
                    if (res.Length > 1048576)  //Try one Megabyte, two seems too big         //2097152
                    {                        
                            large = true;
                            GlobalVars.filename = GetNewTempFile(".html");
                            //MessageBox.Show(filename);
                            File.WriteAllText(GlobalVars.filename, res);
                            webView21.Source = new Uri(GlobalVars.filename);
                            
                    }
                    if (large == false)
                    {
                        webView21.CoreWebView2.NavigateToString(res);
                    }

                }
                else
                {
                    labelRepository.Text = "Repository ID: ";
                    labelDoc.Text = "Document ID: ";
                }
            }
            else
            {
                labelRepository.Text = "Repository ID: ";
                labelDoc.Text = "Document ID: ";
                MessageBox.Show("You must first select a document");
            }
            Cursor.Current = Cursors.Default;
        }

        
        async private void StartWebView()
        {
            String userDataFolder = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\HIE-Documents";
            var environment = await CoreWebView2Environment.CreateAsync(null, userDataFolder);
            await webView21.EnsureCoreWebView2Async(environment);
        }
        private void SelectDocument_Load(object sender, EventArgs e)
        {
            String WVExists = "";
            try
            {
                WVExists=CoreWebView2Environment.GetAvailableBrowserVersionString();
            }
            catch (Exception) 
            {
                WVExists=""; 
            }
            if (WVExists == "")
            {
                MessageBox.Show("Sorry, the WebView2 runtime is not installed on this computer.");
                
                this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
                this.Close();
                return;
            }            
                                    
            labelMessage.Text = "Trying to Initialize the Webview2 Component...";
            StartWebView();

            DialogResult dialogResult = MessageBox.Show("1) The information " +
                "requested is protected under HIPAA and other privacy laws" + Environment.NewLine + "    and should not be viewed except by " +
                "authorized users for clinical purposes." + Environment.NewLine + "2)  The HIE records may not " +
                "represent all clinical records " +
                "that exist for this patient." + Environment.NewLine + Environment.NewLine + "Continue?", "Acknowledgement Form"
                , MessageBoxButtons.YesNo);
            if (dialogResult != DialogResult.Yes)
            {               

                this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
                this.Close();
                return;
            }
            
            String PatDFN = "";
            String userDUZ = "";
            String server = "";
            int port = 0;
            String[] arguments = Environment.GetCommandLineArgs();
            string thisarg = "";
            for (int iii = 0; iii < arguments.GetLength(0); iii++)
            {
                thisarg = arguments[iii].ToUpper();
                if (thisarg.StartsWith("DFN="))
                {
                    PatDFN = thisarg.Substring(4);
                    GlobalVars.currentpatientDFN = PatDFN;
                }
                if (thisarg.StartsWith("DUZ="))
                {
                    userDUZ = thisarg.Substring(4);
                }
                if (thisarg.StartsWith("SRV="))
                {
                    server = thisarg.Substring(4);
                }
                if (thisarg.StartsWith("PORT="))
                {
                    port = Convert.ToInt32(thisarg.Substring(5));
                }

            }
            
            // set up domain context
            System.Security.Principal.SecurityIdentifier usersSid = null;
            PrincipalContext ctx = new PrincipalContext(ContextType.Domain);

            // find a user
            UserPrincipal user = UserPrincipal.FindByIdentity(ctx, Environment.UserName);

            if (user != null)
            {

                usersSid = user.Sid;

            }
            GlobalVars.dc = new DataConnection("AD_CONNECT", server, port, true);

            string AV_ARG = "";
            string[] results;
            string NO_ARG = RpcFormatter.FormatArgs(true, new string[0]);
            string res3 = GlobalVars.dc.CallRPC("XUS C9CKEYS", NO_ARG);
            results = Common.Split(res3);
            if (results.Length < 3)
            {
                MessageBox.Show("Secure Connection Unavailable!");
                this.Close();
            }
            int key = Convert.ToInt32(results[0]);
            int c1 = Convert.ToInt32(results[1]);
            int c2 = Convert.ToInt32(results[2]);

            string openstr = "VistA Active Directory Connect^~" + (Environment.UserDomainName + '\\' + Environment.UserName).ToUpper();
            string CRHEnopenstr = CRHPrivate.CRHEncrypt(openstr, key, c1, c2);
            string enstr = Hash.Encrypt(CRHEnopenstr);

            //Begin send parameter for S.DS.AM identity check
            string SIDstring = "";
            string encSID = "";
            string encAPPL = "";
            SIDstring = CRHPrivate.CRHEncrypt(usersSid.ToString(), key, c1, c2);
            encSID = Hash.Encrypt(SIDstring);
            encAPPL = Hash.Encrypt(CRHPrivate.CRHEncrypt("HIE Document Browser", key, c1, c2));
            AV_ARG = RpcFormatter.FormatArgs(true, "-35^" + enstr, encAPPL, encSID);
            //End send parameter for S.DS.AM identity check
            string res = GlobalVars.dc.CallRPC("XUS SIGNON SETUP", AV_ARG);
            results = Common.Split(res);
            

            string context = "OR CPRS GUI CHART";
            string res2 = GlobalVars.dc.CallRPC("XWB CREATE CONTEXT", RpcFormatter.FormatArgs(true, Hash.Encrypt(context)));
            results = Common.Split(res2);

            string res4 = GlobalVars.dc.CallRPC("XUS GET USER INFO", NO_ARG);
            results = Common.Split(res4);
            int DUZ = 0;

            Int32.TryParse(results[0], out DUZ);
            if (DUZ > 0)
            {
                GlobalVars.CurrentUserDUZ = DUZ;

                comboBoxDocs.DrawMode = DrawMode.OwnerDrawFixed;  //May 20, 2022
                comboBoxDocs.DrawItem += comboBoxDocs_DrawItem;   //May 20, 2022
                comboBoxDocs.DropDownClosed += comboBoxDocs_DropDownClosed; //May 20, 2022

            }
            else
            {
                MessageBox.Show("Unable to log in!");
            }
            
        }

        private void comboBoxDocs_DropDownClosed(object sender, EventArgs e) //May 20, 2022
        {                                                                    //May 20, 2022
            toolTip1.Hide(comboBoxDocs);                                     //May 20, 2022
        }                                                                    //May 20, 2022

        private void comboBoxDocs_DrawItem(object sender, DrawItemEventArgs e)  
        {
            if (e.Index < 0) { return; }            
            string text = "";            
            string UIDs = ((GlobalVars.NType)(comboBoxDocs.Items)[e.Index]).valueForCombo;

            string[] IDs = Common.Split(UIDs, '%');
            if (IDs.Length == 2)
            {
                string repo = IDs[0];
                string docid = IDs[1];
                text = "Repository ID: " + repo;
                text = text + "    Document ID: " + docid;
            }

            Font drawFont = new Font("Lucida Console", 10.0f);
            e.DrawBackground(); 
            using (SolidBrush br = new SolidBrush(e.ForeColor)) 
            { e.Graphics.DrawString(((GlobalVars.NType)(comboBoxDocs.Items)[e.Index]).showInCombo, drawFont, br, e.Bounds); } 
            if ((e.State & DrawItemState.Selected) == DrawItemState.Selected)
            //{ toolTip1.Show(text, comboBoxDocs, e.Bounds.Right, e.Bounds.Bottom); }
            { toolTip1.Show(text, comboBoxDocs, e.Bounds.Left, e.Bounds.Bottom + 20); }
            e.DrawFocusRectangle();
        }                                                                   
        private void webView21_CoreWebView2InitializationCompleted(object sender, Microsoft.Web.WebView2.Core.CoreWebView2InitializationCompletedEventArgs e)
        {
            if (e.IsSuccess)
            {
                webView21.CoreWebView2.NavigateToString("<p>Document Not Yet Selected...</p>");
                labelMessage.Text = "";
                comboBoxDocs.Enabled = true;
            }
            else
            {
                if ((labelMessage.Text != "HIE Documents Not Found For This Patient!") && (!(labelMessage.Text).StartsWith("ERROR"))
                    && (labelMessage.Text != "Patient Not Found/Not Matched in HIE!"))
                {
                    labelMessage.Text = "Microsoft Edge Version May Not Be Compatible!";
                }
            }
        }

        private void webView21_NavigationCompleted(object sender, Microsoft.Web.WebView2.Core.CoreWebView2NavigationCompletedEventArgs e)
        {
            GlobalVars.pageloaded = true;            
        }

        private void SelectDocument_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (GlobalVars.filename != "")
            {
                File.Delete(GlobalVars.filename);
                GlobalVars.filename = "";
            }
            
        }

        private void comboBoxTimePeriod_SelectedIndexChanged(object sender, EventArgs e)
        {            
            webView21.CoreWebView2.NavigateToString("<p>Document Not Yet Selected...</p>");
            labelMessage.Text = "";
            comboBoxDocs.Enabled = false;
            comboBoxDocs.Items.Clear();
            Application.DoEvents();

            //C9C HIE GETDOCS
            string numDays = comboBoxTimePeriod.Text;
            if (numDays == "")
            {
                numDays = "90";
                comboBoxTimePeriod.Text = "90";
            }

            string[] args1 = { GlobalVars.currentpatientDFN, numDays };

            
            string THIS_ARG = RpcFormatter.FormatArgs(true, args1);
            string res = GlobalVars.RunRPC("C9C HIE GETDOCS", THIS_ARG);
            res = res.Replace("\r", string.Empty);

            string[] results = Common.Split(res, '\n');

            if (results.Length > 0)
            {
                if (results[0].Trim(' ') == "XDSTooManyResults")
                {
                    labelMessage.Text = "Too Many Results To Return - Try a Shorter Timespan!";
                    Application.DoEvents();
                    labelMessage.Refresh();
                    comboBoxDocs.Enabled = false;
                }
                else if ((results[0].Trim(' ') == "HIE Documents Not Found For This Patient!") || (results[0].Trim(' ') == "Patient Not Found/Not Matched in HIE!")
                                            || (results[0].Trim(' ') == "Could Not Communicate With the HIE!")
                                            || (results[0].Trim(' ').StartsWith("ERROR")))
                {
                    labelMessage.Text = results[0];
                    Application.DoEvents();

                    labelMessage.Refresh();
                    comboBoxDocs.Enabled = false;
                }
                else
                {                    
                    //labelMessage.Text = "Attempting to Initialize the WebView2 Component...";
                    for (int q = 0; q < results.Length; q++)
                    {

                        string[] thisresult = Common.Split(results[q], '%');
                        if (thisresult.Length > 12)
                        {
                            if (thisresult[12] == "")
                            {
                                thisresult[12] = thisresult[2]; //Use facility if author institution is blank
                            }
                            var thisitem = new GlobalVars.NType
                            {
                                facilityUID = thisresult[0],
                                documentUID = thisresult[1],
                                facility = thisresult[2],  //this is actually sending system, maybe AllScripts, etc
                                facilityPatID = thisresult[3],
                                documentLOINC = thisresult[5],
                                documentTitle = thisresult[6],
                                documentEncoding = thisresult[7],
                                documentDateTime = thisresult[8],
                                authorInstitution = thisresult[12],
                                showInCombo = thisresult[8].PadRight(25) + thisresult[4].PadRight(50) + thisresult[12],
                                valueForCombo = thisresult[0] + "%" + thisresult[1]
                            };
                            comboBoxDocs.Items.Add(thisitem);

                        }
                    }
                }
            }

            if ((comboBoxDocs.Items.Count == 0) || ((comboBoxDocs.Items.Count == 1) && (comboBoxDocs.Items[0].ToString().Trim() == "")))
            {
                if (labelMessage.Text == "")
                {                    
                    labelMessage.Text = "HIE Documents Not Found For This Patient During Selected Timeframe!";
                }
            }
            else
            {
                labelMessage.Text = "";
                comboBoxDocs.Enabled = true;
            }
            Cursor.Current = Cursors.Default;
        }
    }
}
