﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Medsphere.OpenVista.Remoting;
using Medsphere.OpenVista.Shared;
using System.Security.Principal;
using System.DirectoryServices.AccountManagement;
using System.Collections;
using System.Drawing.Printing;
using System.IO;


namespace On_Call_Signout
{
    public partial class ShowStickyNotes : Form
    {
        public ShowStickyNotes()
        {
            InitializeComponent();
        }

        private void ShowStickyNotes_Load(object sender, EventArgs e)
        {
            if (GlobalVars.CurrentUserDUZ != 0)
            {
                string NO_ARG = RpcFormatter.FormatArgs(true, new string[0]);
                GlobalVars.CurrentUserService = GlobalVars.dc.CallRPC("C9C GET USER SERVICE", NO_ARG);
                if (GlobalVars.CurrentUserService == "MED")
                {
                    radioButtonMedical.Checked = true;
                }
                else if (GlobalVars.CurrentUserService == "PSY")
                {
                    radioButtonPsychiatry.Checked = true;
                }
                else
                {
                    radioButtonAll.Checked = true;
                }

                LoadDataGridView();
                dgSNotes.Sort(dgSNotes.Columns["CreatedDateTime"], ListSortDirection.Descending);
                if (dgSNotes.RowCount > 0)
                {
                    Boolean visFound = false;
                    for (int p = 0; ((p < dgSNotes.RowCount) && (visFound == false)); p++)
                    {
                        if ((visFound == false) && (dgSNotes.Rows[p].Visible == true))
                        {
                            dgSNotes.Rows[p].Selected = true;
                            dgSNotes.CurrentCell = dgSNotes.Rows[p].Cells["SVC"];
                            visFound = true;
                        }

                    }
                }
            }
            else
            {
                MessageBox.Show("Unable to log in!");
                Application.Exit();
            }
        }


        private void groupBoxService_Paint(object sender, PaintEventArgs e)
        {
            // Call the OnPaint method of the base class.  
            base.OnPaint(e);
            // Call methods of the System.Drawing.Graphics object.


            Brush borderBrush = new SolidBrush(Color.Blue);
            Brush textBrush = new SolidBrush(Color.Red);

            Pen borderPen = new Pen(borderBrush);
            borderPen.Width = 1.0F;
            borderPen.LineJoin = System.Drawing.Drawing2D.LineJoin.Round;

            Font drawFontBold = new Font("Arial", 9, FontStyle.Bold);

            SizeF strSize = e.Graphics.MeasureString(groupBoxService.Text, drawFontBold);
            Rectangle rect = new Rectangle(groupBoxService.ClientRectangle.X,
                                           groupBoxService.ClientRectangle.Y + (int)(strSize.Height / 2),
                                           groupBoxService.ClientRectangle.Width - 1,
                                           groupBoxService.ClientRectangle.Height - (int)(strSize.Height / 2) - 1);
            // Clear text and border
            e.Graphics.Clear(groupBoxService.BackColor);
            //e.Graphics.FillRectangle(new SolidBrush(Color.LightGray) ,rect);

            // Draw text
            e.Graphics.DrawString(groupBoxService.Text, drawFontBold, textBrush, groupBoxService.Padding.Left, 0);
            // Drawing Border
            //Left
            e.Graphics.DrawLine(borderPen, rect.Location, new Point(rect.X, rect.Y + rect.Height));
            //Right
            e.Graphics.DrawLine(borderPen, new Point(rect.X + rect.Width, rect.Y), new Point(rect.X + rect.Width, rect.Y + rect.Height));
            //Bottom
            e.Graphics.DrawLine(borderPen, new Point(rect.X, rect.Y + rect.Height), new Point(rect.X + rect.Width, rect.Y + rect.Height));
            //Top1
            e.Graphics.DrawLine(borderPen, new Point(rect.X, rect.Y), new Point(rect.X + groupBoxService.Padding.Left, rect.Y));
            //Top2
            e.Graphics.DrawLine(borderPen, new Point(rect.X + groupBoxService.Padding.Left + (int)(strSize.Width), rect.Y), new Point(rect.X + rect.Width, rect.Y));

            borderPen.Dispose();

        }





        private void DrawGroupBox(GroupBox box, Graphics g, Color textColor, Color borderColor)
        {
            if (box != null)
            {
                Brush textBrush = new SolidBrush(textColor);
                Brush borderBrush = new SolidBrush(borderColor);
                Pen borderPen = new Pen(borderBrush);
                SizeF strSize = g.MeasureString(box.Text, box.Font);
                Rectangle rect = new Rectangle(box.ClientRectangle.X,
                                               box.ClientRectangle.Y + (int)(strSize.Height / 2),
                                               box.ClientRectangle.Width - 1,
                                               box.ClientRectangle.Height - (int)(strSize.Height / 2) - 1);

                // Clear text and border
                g.Clear(this.BackColor);

                // Draw text
                g.DrawString(box.Text, box.Font, textBrush, box.Padding.Left, 0);

                // Drawing Border
                //Left
                g.DrawLine(borderPen, rect.Location, new Point(rect.X, rect.Y + rect.Height));
                //Right
                g.DrawLine(borderPen, new Point(rect.X + rect.Width, rect.Y), new Point(rect.X + rect.Width, rect.Y + rect.Height));
                //Bottom
                g.DrawLine(borderPen, new Point(rect.X, rect.Y + rect.Height), new Point(rect.X + rect.Width, rect.Y + rect.Height));
                //Top1
                g.DrawLine(borderPen, new Point(rect.X, rect.Y), new Point(rect.X + box.Padding.Left, rect.Y));
                //Top2
                g.DrawLine(borderPen, new Point(rect.X + box.Padding.Left + (int)(strSize.Width), rect.Y), new Point(rect.X + rect.Width, rect.Y));
            }
        }

        private void LoadDataGridView()
        {
            string NO_ARG = RpcFormatter.FormatArgs(true, new string[0]);
            string res5 = GlobalVars.dc.CallRPC("C9C ON-CALL SIGN OUT DATA", NO_ARG);
            string[] results = Common.Split(res5);
            if (results.Length < 1)
            {
                MessageBox.Show("No Provider/On-Call Signout Notes Found.");
                this.Close();
            }
            else
            {
                dgSNotes.Columns["NoteText"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dgSNotes.Columns["CreatedDateTime"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dgSNotes.Columns["ExpirationDateTime"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dgSNotes.Columns["PCU"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dgSNotes.Columns["WrittenBy"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dgSNotes.Columns["Attending"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dgSNotes.Columns["PatientName"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                dgSNotes.Columns["SVC"].DefaultCellStyle.WrapMode = DataGridViewTriState.True;
                for (int i = 0; i < results.Length; i++)
                {
                    string[] noteSplit = results[i].Split('^');
                    if (noteSplit.Length > 11)
                    {
                        string createdDateTime = noteSplit[9];
                        string expiresDateTime = noteSplit[10];
                        DateTime temp;

                        DateTime? createdOut = new DateTime?();  //make nullable
                        DateTime? expiresOut = new DateTime?();  //make nullable

                        if (DateTime.TryParse(createdDateTime, out temp))
                        {
                            createdOut = temp;
                        }

                        if (DateTime.TryParse(expiresDateTime, out temp))
                        {
                            expiresOut = temp;
                        }

                        string attcov = noteSplit[2];
                        if (attcov.Contains("/"))
                        {
                            attcov = attcov.Replace("/", "/" + Environment.NewLine);
                        }
                        int rownum = dgSNotes.Rows.Add(noteSplit[1], noteSplit[3], noteSplit[4], noteSplit[5], noteSplit[6],
                            noteSplit[7], noteSplit[8], attcov, createdOut, expiresOut, "");
                        if (noteSplit[0] == "Future Reminder")
                        {
                            dgSNotes.Rows[rownum].DefaultCellStyle.BackColor = Color.LightYellow;
                            dgSNotes.Rows[rownum].DefaultCellStyle.ForeColor = Color.Black;
                            dgSNotes.Rows[rownum].DefaultCellStyle.SelectionBackColor = Color.Yellow;
                            dgSNotes.Rows[rownum].DefaultCellStyle.SelectionForeColor = Color.Black;

                        }
                        else
                        {
                            dgSNotes.Rows[rownum].DefaultCellStyle.BackColor = Color.LightBlue;
                            dgSNotes.Rows[rownum].DefaultCellStyle.ForeColor = Color.Black;
                            dgSNotes.Rows[rownum].DefaultCellStyle.SelectionBackColor = Color.Blue;
                            dgSNotes.Rows[rownum].DefaultCellStyle.SelectionForeColor = Color.White;
                        }

                        string noteText = "";
                        for (int q = 11; q < noteSplit.Length; q++)
                        {
                            if (noteText == "")
                            {
                                noteText = noteSplit[q];
                            }
                            else
                            {
                                noteText = noteText + Environment.NewLine + noteSplit[q];
                            }
                        }
                        dgSNotes.Rows[rownum].Cells["NoteText"].Value = noteText;
                    }
                }
            }
            int selectedRow = -1;
            if (radioButtonPsychiatry.Checked)
            {
                for (int u = 0; u < dgSNotes.RowCount; u++)
                {

                    if (dgSNotes.Rows[u].Cells["SVC"].Value.ToString() == "PSY")
                    {
                        dgSNotes.Rows[u].Visible = true;
                        if (selectedRow == -1)
                        {
                            selectedRow = u;
                        }
                    }
                    else
                    {
                        dgSNotes.Rows[u].Visible = false;
                    }
                }
            }
            else if (radioButtonMedical.Checked)
            {
                for (int u = 0; u < dgSNotes.RowCount; u++)
                {

                    if (dgSNotes.Rows[u].Cells["SVC"].Value.ToString() == "MED")
                    {
                        dgSNotes.Rows[u].Visible = true;
                        if (selectedRow == -1)
                        {
                            selectedRow = u;
                        }
                    }
                    else
                    {
                        dgSNotes.Rows[u].Visible = false;
                    }
                }
            }
            dgSNotes.Focus();
            if (selectedRow > -1)
            {
                dgSNotes.Rows[selectedRow].Selected = true;
                dgSNotes.CurrentCell = dgSNotes.Rows[selectedRow].Cells["SVC"];
            }
        }

        private void timerKeepAlive_Tick(object sender, EventArgs e)
        {
            string NO_ARG = RpcFormatter.FormatArgs(true, new string[0]);
            string res3 = GlobalVars.dc.CallRPC("XOBV TEST PING", NO_ARG);
        }

        //used for printing
        StringFormat strFormat; //Used to format the grid rows.
        ArrayList arrColumnLefts = new ArrayList();//Used to save left coordinates of columns
        ArrayList arrColumnWidths = new ArrayList();//Used to save column widths
        int iCellHeight = 0; //Used to get/set the datagridview cell height
        int iTotalWidth = 0; //
        int iRow = 0;//Used as counter
        bool bFirstPage = false; //Used to check whether we are printing first page
        bool bNewPage = false; // Used to check whether we are printing a new page
        int iHeaderHeight = 0; //Used for the header height
        String[] strVisibleColumns = { "PatientName", "MRN", "PCU", "WrittenBy", "SVC", "Attending", "CreatedDateTime", "ExpirationDateTime", "NoteText" };
        //end used for printing

        private void printDocument1_BeginPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
        {
            try
            {
                strFormat = new StringFormat();
                strFormat.Alignment = StringAlignment.Near;
                strFormat.LineAlignment = StringAlignment.Center;
                strFormat.Trimming = StringTrimming.EllipsisCharacter;

                arrColumnLefts.Clear();
                arrColumnWidths.Clear();
                iCellHeight = 0;
                bFirstPage = true;
                bNewPage = true;
                iRow = 0;

                // Calculating Total Widths
                iTotalWidth = 0;
                foreach (DataGridViewColumn dgvGridCol in dgSNotes.Columns)
                {
                    if (strVisibleColumns.Any(dgvGridCol.Name.Equals))
                    {
                        iTotalWidth += dgvGridCol.Width;
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            try
            {

                //Set the left margin
                int iLeftMargin = e.MarginBounds.Left;
                //Set the top margin
                int iTopMargin = e.MarginBounds.Top;
                //Whether more pages have to print or not
                bool bMorePagesToPrint = false;
                int iTmpWidth = 0;

                Font contentFont = new Font("Arial Narrow", 8, FontStyle.Regular);
                Font headerFont = new Font("Arial Narrow", 8, FontStyle.Bold);
                //For the first page to print set the cell width and header height
                if (bFirstPage)
                {
                    foreach (DataGridViewColumn GridCol in dgSNotes.Columns)
                    {
                        if (strVisibleColumns.Any(GridCol.Name.Equals))
                        {
                            iTmpWidth = (int)(Math.Floor((double)((double)GridCol.Width /
                            (double)iTotalWidth * (double)iTotalWidth *
                            ((double)e.MarginBounds.Width / (double)iTotalWidth))));


                            iHeaderHeight = (int)(e.Graphics.MeasureString(GridCol.HeaderText,
                                GridCol.InheritedStyle.Font, iTmpWidth).Height) + 11;

                            // Save width and height of headers
                            arrColumnLefts.Add(iLeftMargin);
                            arrColumnWidths.Add(iTmpWidth);
                            iLeftMargin += iTmpWidth;
                        }
                    }
                }
                //Loop till all the grid rows not get printed
                while (iRow <= dgSNotes.Rows.Count - 1)
                {
                    if (dgSNotes.Rows[iRow].Visible == true)
                    {
                        DataGridViewRow GridRow = dgSNotes.Rows[iRow];
                        //Set the cell height
                        iCellHeight = GridRow.Height + 5;
                        int iCount = 0;
                        //Check whether the current page settings allows more rows to print
                        if (iTopMargin + iCellHeight >= e.MarginBounds.Height + e.MarginBounds.Top)
                        {
                            bNewPage = true;
                            bFirstPage = false;
                            bMorePagesToPrint = true;
                            break;
                        }
                        else
                        {
                            if (bNewPage)
                            {
                                //Draw Header
                                e.Graphics.DrawString("Sticky Notes",
                                    new Font(dgSNotes.Font, FontStyle.Bold),
                                    Brushes.Black, e.MarginBounds.Left,
                                    e.MarginBounds.Top - e.Graphics.MeasureString("Sticky Notes",
                                    new Font(dgSNotes.Font, FontStyle.Bold),
                                    e.MarginBounds.Width).Height - 13);

                                String strDate = DateTime.Now.ToLongDateString() + " " +
                                    DateTime.Now.ToShortTimeString();
                                //Draw Date
                                e.Graphics.DrawString(strDate,
                                    new Font(dgSNotes.Font, FontStyle.Bold), Brushes.Black,
                                    e.MarginBounds.Left +
                                    (e.MarginBounds.Width - e.Graphics.MeasureString(strDate,
                                    new Font(dgSNotes.Font, FontStyle.Bold),
                                    e.MarginBounds.Width).Width),
                                    e.MarginBounds.Top - e.Graphics.MeasureString("Sticky Notes",
                                    new Font(new Font(dgSNotes.Font, FontStyle.Bold),
                                    FontStyle.Bold), e.MarginBounds.Width).Height - 13);

                                //Draw Columns                 
                                iTopMargin = e.MarginBounds.Top;
                                foreach (DataGridViewColumn GridCol in dgSNotes.Columns)
                                {
                                    if (strVisibleColumns.Any(GridCol.Name.Equals))
                                    {
                                        e.Graphics.FillRectangle(new SolidBrush(Color.LightGray),
                                        new Rectangle((int)arrColumnLefts[iCount], iTopMargin,
                                        (int)arrColumnWidths[iCount], iHeaderHeight));

                                        e.Graphics.DrawRectangle(Pens.Black,
                                            new Rectangle((int)arrColumnLefts[iCount], iTopMargin,
                                            (int)arrColumnWidths[iCount], iHeaderHeight));

                                        e.Graphics.DrawString(GridCol.HeaderText,
                                            headerFont,
                                            new SolidBrush(GridCol.InheritedStyle.ForeColor),
                                            new RectangleF((int)arrColumnLefts[iCount], iTopMargin,
                                            (int)arrColumnWidths[iCount], iHeaderHeight), strFormat);
                                        iCount++;
                                    }
                                }
                                bNewPage = false;
                                iTopMargin += iHeaderHeight;
                            }
                            iCount = 0;
                            //Draw Columns Contents                
                            foreach (DataGridViewCell Cel in GridRow.Cells)
                            {
                                if (strVisibleColumns.Any(Cel.OwningColumn.Name.Equals))
                                {
                                    if (Cel.Value != null)
                                    {
                                        e.Graphics.DrawString(Cel.Value.ToString(),
                                            contentFont,
                                            new SolidBrush(Color.Black),
                                            new RectangleF((int)arrColumnLefts[iCount],
                                            (float)iTopMargin,
                                            (int)arrColumnWidths[iCount], (float)iCellHeight),
                                            strFormat);
                                    }
                                    //Drawing Cells Borders 
                                    e.Graphics.DrawRectangle(Pens.Black,
                                        new Rectangle((int)arrColumnLefts[iCount], iTopMargin,
                                        (int)arrColumnWidths[iCount], iCellHeight));
                                    iCount++;
                                }
                            }
                        }
                        iRow++;
                        iTopMargin += iCellHeight;
                    }
                    else
                    {
                        iRow++;
                    }
                }
                //If more lines exist, print another page.
                if (bMorePagesToPrint)
                    e.HasMorePages = true;
                else
                    e.HasMorePages = false;
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message, "Error", MessageBoxButtons.OK,
                   MessageBoxIcon.Error);
            }
        }

        private void buttonPrint_Click(object sender, EventArgs e)
        {
            //Open the print dialog
            PrintDialog printDialog = new PrintDialog();
            printDialog.Document = printDocument1;
            printDialog.UseEXDialog = true;
            //Get the document
            if (DialogResult.OK == printDialog.ShowDialog())
            {
                printDocument1.DocumentName = "Sticky Notes";
                printDocument1.DefaultPageSettings.Landscape = true;
                Margins margins = new Margins(50, 50, 50, 50);
                printDocument1.DefaultPageSettings.Margins = margins;
                printDocument1.Print();

            }
            dgSNotes.Focus();
        }

        private void buttonRefresh_Click(object sender, EventArgs e)
        {
            SortOrder sOrder = this.dgSNotes.SortOrder;
            ListSortDirection sDir = ListSortDirection.Descending;
            if (sOrder == SortOrder.Ascending)
            {
                sDir = ListSortDirection.Ascending;
            }

            DataGridViewColumn c = this.dgSNotes.SortedColumn;
            dgSNotes.Rows.Clear();
            LoadDataGridView();
            dgSNotes.Sort(c, sDir);
            dgSNotes.Focus();
        }

        private void buttonExpire_Click(object sender, EventArgs e)
        {
            int selectedRow = -1;
            selectedRow = dgSNotes.CurrentCell.RowIndex;
            if (selectedRow > -1)
            {
                string exdata = dgSNotes.Rows[selectedRow].Cells["IENs"].Value.ToString();
                string[] exSplit = exdata.Split(':');
                if (exSplit.Length > 1)
                {
                    string patdfn = exSplit[0];
                    string recno = exSplit[1];
                    Color saveBcolor = dgSNotes.Rows[selectedRow].DefaultCellStyle.SelectionBackColor;
                    Color saveFcolor = dgSNotes.Rows[selectedRow].DefaultCellStyle.SelectionForeColor;

                    dgSNotes.Rows[selectedRow].DefaultCellStyle.SelectionBackColor = Color.Red;
                    dgSNotes.Rows[selectedRow].DefaultCellStyle.SelectionForeColor = Color.White;

                    DialogResult dialogResult = MessageBox.Show("Expire the highlighted note?", "Expire Note", MessageBoxButtons.YesNo);
                    if (dialogResult == DialogResult.No)
                    {
                        dgSNotes.Rows[selectedRow].DefaultCellStyle.SelectionBackColor = saveBcolor;
                        dgSNotes.Rows[selectedRow].DefaultCellStyle.SelectionForeColor = saveFcolor;
                    }
                    else if (dialogResult == DialogResult.Yes)
                    {
                        String AV_ARG = RpcFormatter.FormatArgs(true, patdfn, recno);
                        string res = GlobalVars.dc.CallRPC("C9C FORCE STICKY NOTE EXP", AV_ARG);
                        string[] results = Common.Split(res);
                        if (results.Length > 0)
                        {
                            if (results[0] != "1")
                            {
                                MessageBox.Show("There was a problem expiring that note!");
                            }
                            else
                            {
                                dgSNotes.Rows.Clear();
                                SortOrder sOrder = this.dgSNotes.SortOrder;
                                ListSortDirection sDir = ListSortDirection.Descending;
                                if (sOrder == SortOrder.Ascending)
                                {
                                    sDir = ListSortDirection.Ascending;
                                }

                                DataGridViewColumn c = this.dgSNotes.SortedColumn;
                                dgSNotes.Rows.Clear();
                                LoadDataGridView();
                                dgSNotes.Sort(c, sDir);
                            }
                        }
                    }
                    dgSNotes.Focus();
                }
            }


        }

        private void buttonExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void radioButtonPsychiatry_CheckedChanged(object sender, EventArgs e)
        {
            int selectedRow = -1;
            if (radioButtonPsychiatry.Checked)
            {
                for (int u = 0; u < dgSNotes.RowCount; u++)
                {

                    if (dgSNotes.Rows[u].Cells["SVC"].Value.ToString() == "PSY")
                    {
                        dgSNotes.Rows[u].Visible = true;
                        if (selectedRow == -1)
                        {
                            selectedRow = u;
                        }
                    }
                    else
                    {
                        dgSNotes.Rows[u].Visible = false;
                    }
                }
            }
            dgSNotes.Focus();
            if (selectedRow > -1)
            {
                dgSNotes.Rows[selectedRow].Selected = true;
                dgSNotes.CurrentCell = dgSNotes.Rows[selectedRow].Cells["SVC"];
            }
        }

        private void radioButtonMedical_CheckedChanged(object sender, EventArgs e)
        {
            int selectedRow = -1;
            if (radioButtonMedical.Checked)
            {
                for (int u = 0; u < dgSNotes.RowCount; u++)
                {

                    if (dgSNotes.Rows[u].Cells["SVC"].Value.ToString() == "MED")
                    {
                        dgSNotes.Rows[u].Visible = true;
                        if (selectedRow == -1)
                        {
                            selectedRow = u;
                        }
                    }
                    else
                    {
                        dgSNotes.Rows[u].Visible = false;
                    }
                }
            }
            dgSNotes.Focus();
            if (selectedRow > -1)
            {
                dgSNotes.Rows[selectedRow].Selected = true;
                dgSNotes.CurrentCell = dgSNotes.Rows[selectedRow].Cells["SVC"];
            }

        }

        private void radioButtonAll_CheckedChanged(object sender, EventArgs e)
        {
            int selectedRow = -1;
            if (radioButtonAll.Checked)
            {
                for (int u = 0; u < dgSNotes.RowCount; u++)
                {
                    dgSNotes.Rows[u].Visible = true;
                    if (selectedRow == -1)
                    {
                        selectedRow = u;
                    }
                }
            }
            dgSNotes.Focus();
            if (selectedRow > -1)
            {
                dgSNotes.Rows[selectedRow].Selected = true;
                dgSNotes.CurrentCell = dgSNotes.Rows[selectedRow].Cells["SVC"];
            }
        }

        private void dgSNotes_CellPainting(object sender, DataGridViewCellPaintingEventArgs e)
        {

            var grid = (DataGridView)sender;
            var sortIconColor = Color.Red;
            if (e.RowIndex == -1 && e.ColumnIndex > -1)
            {
                using (var b = new SolidBrush(BackColor))
                {
                    //Draw Background
                    e.PaintBackground(e.CellBounds, false);

                    //Draw Text Default
                    //e.Paint(e.CellBounds, DataGridViewPaintParts.ContentForeground);

                    //Draw Text Custom
                    TextRenderer.DrawText(e.Graphics, string.Format("{0}", e.FormattedValue),
                        e.CellStyle.Font, e.CellBounds, e.CellStyle.ForeColor,
                        TextFormatFlags.VerticalCenter | TextFormatFlags.Left);

                    //Draw Sort Icon
                    if (grid.SortedColumn?.Index == e.ColumnIndex)
                    {
                        var sortIcon = grid.SortOrder == SortOrder.Ascending ? "▲" : "▼";

                        //Or draw an icon here.
                        TextRenderer.DrawText(e.Graphics, sortIcon,
                            e.CellStyle.Font, e.CellBounds, sortIconColor,
                            TextFormatFlags.VerticalCenter | TextFormatFlags.Right);
                    }

                    //Prevent Default Paint
                    e.Handled = true;
                }
            }
        }

        private void timerRefresh_Tick(object sender, EventArgs e)
        {
            SortOrder sOrder = this.dgSNotes.SortOrder;
            ListSortDirection sDir = ListSortDirection.Descending;
            if (sOrder == SortOrder.Ascending)
            {
                sDir = ListSortDirection.Ascending;
            }

            DataGridViewColumn c = this.dgSNotes.SortedColumn;
            dgSNotes.Rows.Clear();
            LoadDataGridView();
            dgSNotes.Sort(c, sDir);
            dgSNotes.Focus();
        }
    }
}
